Imports System.Xml
Imports System.IO

Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim file_name As String = My.Computer.FileSystem.CombinePath(".", "..\..\users.xml")
        LoadXmlFileIntoStructures(file_name)
    End Sub

    Private Sub LoadXmlFileIntoStructures(ByVal file_name As String)
        lstUsers.Items.Clear()

        Dim xml_doc As New XmlDocument
        xml_doc.Load(file_name)

        ' Find the Class node.
        Dim class_node As XmlNode = xml_doc.DocumentElement

        ' Loop through the App nodes.
        For Each app_node As XmlNode In class_node.ChildNodes
            Dim app_name As String = app_node.Name

            ' Loop through the app's Project nodes.
            For Each project_node As XmlNode In app_node.ChildNodes
                ' Create a User structure.
                Dim new_user As New User()

                ' Set the app and project name.
                new_user.AppClass = app_name
                new_user.Proj = project_node.Name

                ' Make it read the rest of its properties.
                new_user.ReadFromXml(project_node)

                ' Add it to the ListBox.
                lstUsers.Items.Add(new_user)
            Next project_node
        Next app_node
    End Sub
End Class

Public Structure User
    Dim AppClass As String
    Dim Proj As String
    Dim Client As String
    Dim City As String
    Dim State As String

    ' Read the user's values from the Project node.
    Public Sub ReadFromXml(ByVal project_node As XmlNode)
        Me.Client = project_node.Item("Client").InnerText
        Me.City = project_node.Item("City").InnerText
        Me.State = project_node.Item("State").InnerText
    End Sub

    ' Return a simple string representation of the User.
    Public Overrides Function ToString() As String
        Return Me.AppClass & ", " & Me.Proj & ", " & Me.Client & ", " & Me.City & ", " & Me.State
    End Function
End Structure